package se.pmws1213.diaballik.controller;

import java.beans.PropertyChangeEvent;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import se.pmws1213.Field;
import se.pmws1213.Holder;
import se.pmws1213.diaballik.Util;
import se.pmws1213.diaballik.gui.DiaballikMainScreen;

public class HolderController extends AbstractController
{
	private Holder holder;
	private DiaballikMainScreen mainScreen;

	public HolderController(DiaballikMainScreen mainScreen, Holder holder)
	{
		this.mainScreen = mainScreen;
		this.holder = holder;
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt)
	{
		refreshUI();
	}

	@Override
	public void refreshUI()
	{
		Display.getDefault().asyncExec(new Runnable() {
			
			@Override
			public void run()
			{
				Field field = holder.getField();
				Image img = Util.getImage(field);
				
				Label label = Util.findLabelForField(mainScreen, field);
				label.setImage(img);
			}
		});
	}

	@Override
	public void registerListeners() {
		listenTo(Holder.PROPERTY_BALL, holder);
	}
	
}
